/****************************************************************************
*
*                            Open Watcom Project
*
*  Copyright (c) 2004-2009 The Open Watcom Contributors. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Implementation of the entry point for Win32 applications.
*
****************************************************************************/


#include "stdafx.h"
#include "threadit.h"

// This file should contain the entry point and nothing else.  This way, it won't
// be linked where it's not needed (such as in a DLL) and create conflicts.

int WINAPI _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine,
                      int nCmdShow )
/**********************************/
{
    if( !AfxWinInit( hInstance, hPrevInstance, lpCmdLine, nCmdShow ) ) {
        return( -1 );
    }
    AfxInitThread();
    
    CWinApp *pApp = AfxGetApp();
    ASSERT( pApp != NULL );
    int nExitCode;
    if( !pApp->InitInstance() ) {
        nExitCode = -1;
    } else {
        nExitCode = pApp->Run();
    }
    AfxTermThread( hInstance );
    return( nExitCode );
}
