/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  WHEN YOU FIGURE OUT WHAT THIS FILE DOES, PLEASE
*               DESCRIBE IT HERE!
*
****************************************************************************/


/*
 * atoetbl -- ASCII to EBCDIC translation table;  (high-bit is "ignored")
 */

char const atoetbl[256]   =
  {
              /* 0x-0, 0x-1, 0x-2, 0x-3, 0x-4, 0x-5, 0x-6, 0x-7, */
              /* 0x-8, 0x-9, 0x-A, 0x-B, 0x-C, 0x-D, 0x-E, 0x-F, */
    /* 0x00 */   0x00, 0x01, 0x02, 0x03, 0x37, 0x2D, 0x2E, 0x2F,
    /* 0x08 */   0x16, 0x05, 0x25, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
    /* 0x10 */   0x10, 0x11, 0x12, 0x13, 0x3C, 0x3D, 0x32, 0x26,
    /* 0x18 */   0x18, 0x19, 0x3F, 0x27, 0x1C, 0x1D, 0x1E, 0x1F,
    /* 0x20 */   0x40, 0x5A, 0x7F, 0x7B, 0x5B, 0x6C, 0x50, 0x7D,
    /* 0x28 */   0x4D, 0x5D, 0x5C, 0x4E, 0x6B, 0x60, 0x4B, 0x61,
    /* 0x30 */   0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7,
    /* 0x38 */   0xF8, 0xF9, 0x7A, 0x5E, 0x4C, 0x7E, 0x6E, 0x6F,
    /* 0x40 */   0x7C, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7,
    /* 0x48 */   0xC8, 0xC9, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6,
    /* 0x50 */   0xD7, 0xD8, 0xD9, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6,
    /* 0x58 */   0xE7, 0xE8, 0xE9, 0xAD, 0xE0, 0xBD, 0x5F, 0x6D,
    /* 0x60 */   0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
    /* 0x68 */   0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
    /* 0x70 */   0x97, 0x98, 0x99, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6,
    /* 0x78 */   0xA7, 0xA8, 0xA9, 0xC0, 0x4F, 0xD0, 0xA1, 0x07,
              /* 0x-0, 0x-1, 0x-2, 0x-3, 0x-4, 0x-5, 0x-6, 0x-7, */
              /* 0x-8, 0x-9, 0x-A, 0x-B, 0x-C, 0x-D, 0x-E, 0x-F, */

    /* Second verse, same as the first... */
              /* 0x-0, 0x-1, 0x-2, 0x-3, 0x-4, 0x-5, 0x-6, 0x-7, */
              /* 0x-8, 0x-9, 0x-A, 0x-B, 0x-C, 0x-D, 0x-E, 0x-F, */
    /* 0x80 */   0x00, 0x01, 0x02, 0x03, 0x37, 0x2D, 0x2E, 0x2F,
    /* 0x88 */   0x16, 0x05, 0x25, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
    /* 0x90 */   0x10, 0x11, 0x12, 0x13, 0x3C, 0x3D, 0x32, 0x26,
    /* 0x98 */   0x18, 0x19, 0x3F, 0x27, 0x1C, 0x1D, 0x1E, 0x1F,
    /* 0xA0 */   0x40, 0x5A, 0x7F, 0x7B, 0x5B, 0x6C, 0x50, 0x7D,
    /* 0xA8 */   0x4D, 0x5D, 0x5C, 0x4E, 0x6B, 0x60, 0x4B, 0x61,
    /* 0xB0 */   0xF0, 0xF1, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 0xF7,
    /* 0xB8 */   0xF8, 0xF9, 0x7A, 0x5E, 0x4C, 0x7E, 0x6E, 0x6F,
    /* 0xC0 */   0x7C, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7,
    /* 0xC8 */   0xC8, 0xC9, 0xD1, 0xD2, 0xD3, 0xD4, 0xD5, 0xD6,
    /* 0xD0 */   0xD7, 0xD8, 0xD9, 0xE2, 0xE3, 0xE4, 0xE5, 0xE6,
    /* 0xD8 */   0xE7, 0xE8, 0xE9, 0xAD, 0xE0, 0xBD, 0x5F, 0x6D,
    /* 0xE0 */   0x79, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87,
    /* 0xE8 */   0x88, 0x89, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96,
    /* 0xF0 */   0x97, 0x98, 0x99, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6,
    /* 0xF8 */   0xA7, 0xA8, 0xA9, 0xC0, 0x4F, 0xD0, 0xA1, 0x07
              /* 0x-0, 0x-1, 0x-2, 0x-3, 0x-4, 0x-5, 0x-6, 0x-7, */
              /* 0x-8, 0x-9, 0x-A, 0x-B, 0x-C, 0x-D, 0x-E, 0x-F, */
  };
