/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Implementation of _atouni() - convert integer to wide string.
*
****************************************************************************/


#include "variety.h"
#include "widechar.h"
#include <string.h>
/* we want to use strlen NOT _ustrlen here */
#undef strlen

/*
 * atouni - convert an ASCII string to a UNICODE string.
 *          buf and src MAY be the same
 */

_WCRTLINK wchar_t *_atouni( wchar_t *buf, const char *src ) 
{
    size_t      len;

    len = strlen( src ) + 1;            /* use single-byte strlen() */
    while( len > 0 ) {
        len --;
        buf[len] = src[len];
    }
    return( buf );
}
