/****************************************************************************
*
*                            Open Watcom Project
*
*    Copyright (c) 2002-2012 Open Watcom Contributors. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Implementation of siginterrupt() for Linux.
*
****************************************************************************/

#include <stdio.h>
#include <signal.h>

_WCRTLINK int siginterrupt( int __signo, int __flag )
{
    struct sigaction    a;

    if( sigaction( __signo, NULL, &a ) < 0 )
        return( -1 );
    if( __flag ) {
        a.sa_flags &= ~SA_RESTART;
    } else {
        a.sa_flags |= SA_RESTART;
    }
    return( sigaction( __signo, &a, NULL ) );
}
