/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  Default 80x87 control word.
*
****************************************************************************/


#include <float.h>

/* This is the default value loaded into the 80x87 control word.
   If you want higher precision, then change PC_53 to PC_64. The
   reason we have the default set to PC_53 is generate reproducible
   floating-point results regardless of the level of optimization
   chosen for the compiler.
   This value is loaded when the 80x87 is initialized by the startup
   code, and also when _fpreset is called.
*/
#pragma aux __8087cw "*";

/*                          0x1000  | 0x0000  | 0x0200 | 0x007F */
unsigned short __8087cw = IC_AFFINE | RC_NEAR | PC_53  | 0x007F;
