/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  WHEN YOU FIGURE OUT WHAT THIS FILE DOES, PLEASE
*               DESCRIBE IT HERE!
*
****************************************************************************/


//
// XFMIN1       : min function for REAL argumemts
//

#include <stdarg.h>

#include "ftnstd.h"
#include "ifenv.h"

#if defined( _M_IX86 )
  #define VAR_SINGLE    single
#else
  #define VAR_SINGLE    double          // required because according to ansi
                                        // we cannot pass singles using varargs
#endif

intstar4 XMIN1( int num_args, ... ) {
//===================================

// Return min( arg1, arg2,... ).

    single      min;
    single      arg;
    int         i;
    va_list     args;

    va_start( args, num_args );
    min = va_arg( args, VAR_SINGLE );
    for( i = 1; i < num_args; i++ ) {
        arg = va_arg( args, VAR_SINGLE );
        if( min > arg ) {
            min = arg;
        }
    }
    va_end( args );
    return( min );
}
