/****************************************************************************
*
*                            Open Watcom Project
*
*    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
*
*  ========================================================================
*
*    This file contains Original Code and/or Modifications of Original
*    Code as defined in and that are subject to the Sybase Open Watcom
*    Public License version 1.0 (the 'License'). You may not use this file
*    except in compliance with the License. BY USING THIS FILE YOU AGREE TO
*    ALL TERMS AND CONDITIONS OF THE LICENSE. A copy of the License is
*    provided with the Original Code and Modifications, and is also
*    available at www.sybase.com/developer/opensource.
*
*    The Original Code and all software distributed under the License are
*    distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
*    EXPRESS OR IMPLIED, AND SYBASE AND ALL CONTRIBUTORS HEREBY DISCLAIM
*    ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF
*    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
*    NON-INFRINGEMENT. Please see the License for the specific language
*    governing rights and limitations under the License.
*
*  ========================================================================
*
* Description:  WHEN YOU FIGURE OUT WHAT THIS FILE DOES, PLEASE
*               DESCRIBE IT HERE!
*
****************************************************************************/


// VFUN_ERR.CPP -- support for trapping calls to stripped virtual calls
//
// This routine should never be called, since only functions which are
// not called virtually should be stripped.
//
// 93/02/04 -- J.W.Welch    -- Defined
// 94/12/12 -- J.W.Welch        -- moved to CPP
// 95/06/14 -- Greg Bentz       -- dll linkage

#include <cpplib.h>
#include "rtmsgs.h"


extern "C"
_WPRTLINK
void CPPLIB(undef_vfun)(        // TRAP STRIPPED VIRTUAL CALLS
    void )
{
    if( !_RWD_UndefVfunFlag ) {
        _RWD_UndefVfunFlag = 1;
        CPPLIB(fatal_runtime_error)( RTMSG_UNDEFED_VFUN, 1 );
    }
}

