The following errors can be generated by the C run-time library.
.ix 'error codes' 'ERRNO.H'
.ix 'errno'
These error codes correspond to the error types defined in
.fi errno.h.
.begnote
.ix 'errno' 'ENOENT'
.note ENOENT
.us No such file or directory
.np
The specified file or directory cannot be found.
.ix 'errno' 'E2BIG'
.note E2BIG
.us Argument list too big
.np
The argument list passed to the
.id spawn...,
.id exec...
or
.id system
functions requires more than 128 bytes, or the environment information
exceeds 32K.
.ix 'errno' 'ENOEXEC'
.note ENOEXEC
.us Exec format error
.np
The executable file has an invalid format.
.ix 'errno' 'EBADF'
.note EBADF
.us Bad file number
.np
The file handle is not a valid file handle value or it does not correspond
to an open file.
.ix 'errno' 'ENOMEM'
.note ENOMEM
.us Not enough memory
.np
There was not enough memory available to perform the specified request.
.ix 'errno' 'EACCES'
.note EACCES
.us Permission denied
.np
You do not have the required (or correct) permissions to access a file.
.ix 'errno' 'EEXIST'
.note EEXIST
.us File exists
.np
An attempt was made to create a file with the O_EXCL (exclusive) flag
when the file already exists.
.ix 'errno' 'EXDEV'
.note EXDEV
.us Cross-device link
.np
An attempt was made to rename a file to a different device.
.ix 'errno' 'EINVAL'
.note EINVAL
.us Invalid argument
.np
An invalid value was specified for one of the arguments to a function.
.ix 'errno' 'ENFILE'
.note ENFILE
.us File table overflow
.np
All the FILE structures are in use, so no more files can be opened.
.ix 'errno' 'EMFILE'
.note EMFILE
.us Too many open files
.np
There are no more file handles available, so no more files can be opened.
The maximum number of file handles available is controlled by the
"FILES=" option in the "CONFIG.SYS" file.
.ix 'errno' 'ENOSPC'
.note ENOSPC
.us No space left on device
.np
No more space is left for writing on the device, which usually means that
the disk is full.
.ix 'errno' 'EDOM'
.note EDOM
.us Argument too large
.np
An argument to a math function is not in the domain of the function.
.ix 'errno' 'ERANGE'
.note ERANGE
.us Result too large
.np
The result of a math function could not be represented (too small, or too
large).
.ix 'errno' 'EDEADLK'
.note EDEADLK
.us Resource deadlock would occur
.np
A resource deadlock would occur with regards to locked files.
.endnote
