The following errors can be generated by the C run-time library.
.ix 'error codes' 'errno.h'
.ix 'errno'
These error codes correspond to the error types defined in
.fi errno.h.
.begnote $setptnt 22
.ix 'errno' 'EOK'
.note EOK (0)
.us No error
.ix 'errno' 'EPERM'
.note EPERM (1)
.us Operation not permitted
.ix 'errno' 'ENOENT'
.note ENOENT (2)
.us No such file or directory
.np
The specified file or directory cannot be found.
.ix 'errno' 'ESRCH'
.note ESRCH (3)
.us No such process
.ix 'errno' 'EINTR'
.note EINTR (4)
.us Interrupted function call
.ix 'errno' 'EIO'
.note EIO (5)
.us I/O error
.ix 'errno' 'ENXIO'
.note ENXIO (6)
.us No such device or address
.ix 'errno' 'E2BIG'
.note E2BIG (7)
.us Arg list too big
.np
The argument list passed to the
.id spawn...,
.id exec...
or
.id system
functions exceeds the limit imposed by QNX, or the environment
information exceeds 64K.
.ix 'errno' 'ENOEXEC'
.note ENOEXEC (8)
.us Exec format error
.np
The executable file has an invalid format.
.ix 'errno' 'EBADF'
.note EBADF (9)
.us Bad file descriptor
.np
The file descriptor is not a valid file descriptor value or it does
not correspond to an open file.
.ix 'errno' 'ECHILD'
.note ECHILD (10)
.us No child processes
.ix 'errno' 'EAGAIN'
.note EAGAIN (11)
.cw !
.us Resource unavailable; try again
.cw ;
.ix 'errno' 'ENOMEM'
.note ENOMEM (12)
.us Not enough memory
.np
There was not enough memory available to perform the specified request.
.ix 'errno' 'EACCES'
.note EACCES (13)
.us Permission denied
.np
You do not have the required (or correct) permissions to access a file.
.ix 'errno' 'EFAULT'
.note EFAULT (14)
.us Bad address
.ix 'errno' 'ENOTBLK'
.note ENOTBLK (15)
.us Block device required
.ix 'errno' 'EBUSY'
.note EBUSY (16)
.us Resource busy
.ix 'errno' 'EEXIST'
.note EEXIST (17)
.us File exists
.np
An attempt was made to create a file with the O_EXCL (exclusive) flag
when the file already exists.
.ix 'errno' 'EXDEV'
.note EXDEV (18)
.us Improper link
.np
An attempt was made to rename a file to a different device.
.ix 'errno' 'ENODEV'
.note ENODEV (19)
.us No such device
.ix 'errno' 'ENOTDIR'
.note ENOTDIR (20)
.us Not a directory
.ix 'errno' 'EISDIR'
.note EISDIR (21)
.us Is a directory
.ix 'errno' 'EINVAL'
.note EINVAL (22)
.us Invalid argument
.np
An invalid value was specified for one of the arguments to a function.
.ix 'errno' 'ENFILE'
.note ENFILE (23)
.us Too many files in the system
.np
All the FILE structures are in use, so no more files can be opened.
.ix 'errno' 'EMFILE'
.note EMFILE (24)
.us Too many open files
.np
There are no more file descriptors available, so no more files can be
opened.
.ix 'errno' 'ENOTTY'
.note ENOTTY (25)
.us Inappropriate I/O control operation
.ix 'errno' 'ETXTBSY'
.note ETXTBSY (26)
.us Text file busy
.ix 'errno' 'EFBIG'
.note EFBIG (27)
.us File too large
.ix 'errno' 'ENOSPC'
.note ENOSPC (28)
.us No space left on device
.np
No more space is left for writing on the device, which usually means that
the disk is full.
.ix 'errno' 'ESPIPE'
.note ESPIPE (29)
.us Invalid seek
.ix 'errno' 'EROFS'
.note EROFS (30)
.us Read-only file system
.ix 'errno' 'EMLINK'
.note EMLINK (31)
.us Too many links
.ix 'errno' 'EPIPE'
.note EPIPE (32)
.us Broken pipe
.ix 'errno' 'EDOM'
.note EDOM (33)
.us Math arg out of domain of func
.np
An argument to a math function is not in the domain of the function.
.ix 'errno' 'ERANGE'
.note ERANGE (34)
.us Result too large
.np
The result of a math function could not be represented (too small, or
too large).
.ix 'errno' 'ENOMSG'
.note ENOMSG (35)
.us No message of desired type
.ix 'errno' 'EIDRM'
.note EIDRM (36)
.us Identifier removed
.ix 'errno' 'ECHRNG'
.note ECHRNG (37)
.us Channel number out of range
.ix 'errno' 'EL2NSYNC'
.note EL2NSYNC (38)
.us Level 2 not synchronized
.ix 'errno' 'EL3HLT'
.note EL3HLT (39)
.us Level 3 halted
.ix 'errno' 'EL3RST'
.note EL3RST (40)
.us Level 3 reset
.ix 'errno' 'ELNRNG'
.note ELNRNG (41)
.us Link number out of range
.ix 'errno' 'EUNATCH'
.note EUNATCH (42)
.us Protocol driver not attached
.ix 'errno' 'ENOCSI'
.note ENOCSI (43)
.us No CSI structure available
.ix 'errno' 'EL2HLT'
.note EL2HLT (44)
.us Level 2 halted
.ix 'errno' 'EDEADLK'
.note EDEADLK (45)
.us Resource deadlock avoided
.np
A resource deadlock would occur with regards to locked files.
.ix 'errno' 'ENOLCK'
.note ENOLCK (46)
.us No locks available
.ix 'errno' 'ELOOP'
.note ELOOP (62)
.us Too many levels of symbolic links or prefixes
.ix 'errno' 'ENAMETOOLONG'
.note ENAMETOOLONG (78)
.us Filename too long
.endnote
.*
.beglevel
.*
.section Shared Library Errors
.*
.begnote $setptnt 22
.ix 'errno' 'ELIBACC'
.note ELIBACC (83)
.us Can't access shared library
.ix 'errno' 'ELIBBAD'
.note ELIBBAD (84)
.us Accessing a corrupted shared library
.ix 'errno' 'ELIBSCN'
.note ELIBSCN (85)
.us ~.lib section in a.out corrupted
.ix 'errno' 'ELIBMAX'
.note ELIBMAX (86)
.us Attempting to link in too many libraries
.ix 'errno' 'ELIBEXEC'
.note ELIBEXEC (87)
.us Attempting to exec a shared library
.ix 'errno' 'ENOSYS'
.note ENOSYS (89)
.us Function not implemented
.ix 'errno' 'ENOTEMPTY'
.note ENOTEMPTY (93)
.us Directory not empty
.ix 'errno' 'EOPNOTSUPP'
.note EOPNOTSUPP (103)
.us Operation not supported
.ix 'errno' 'ESTALE'
.note ESTALE (122)
.us Potentially recoverable i/o error
.endnote
.*
.section Non-blocking and Interrupt I/O
.*
.begnote $setptnt 22
.ix 'errno' 'EWOULDBLOCK'
.note EWOULDBLOCK (11)
.us Operation would block
.ix 'errno' 'EINPROGRESS'
.note EINPROGRESS (236)
.us Operation now in progress
.ix 'errno' 'EALREADY'
.note EALREADY (16)
.us Operation already in progress
.endnote
.*
.section IPC/Network Software -- Argument Errors
.*
.begnote $setptnt 22
.ix 'errno' 'ENOTSOCK'
.note ENOTSOCK (238)
.us Socket operation on non-socket
.ix 'errno' 'EDESTADDRREQ'
.note EDESTADDRREQ (239)
.us Destination address required
.ix 'errno' 'EMSGSIZE'
.note EMSGSIZE (240)
.us Message too long
.ix 'errno' 'EPROTOTYPE'
.note EPROTOTYPE (241)
.us Protocol wrong type for socket
.ix 'errno' 'ENOPROTOOPT'
.note ENOPROTOOPT (242)
.us Protocol not available
.ix 'errno' 'EPROTONOSUPPORT'
.note EPROTONOSUPPORT (243)
.us Protocol not supported
.ix 'errno' 'ESOCKTNOSUPPORT'
.note ESOCKTNOSUPPORT (244)
.us Socket type not supported
.ix 'errno' 'EPFNOSUPPORT'
.note EPFNOSUPPORT (246)
.us Protocol family not supported
.ix 'errno' 'EAFNOSUPPORT'
.note EAFNOSUPPORT (247)
.us Address family not supported by protocol family
.ix 'errno' 'EADDRINUSE'
.note EADDRINUSE (248)
.us Address already in use
.ix 'errno' 'EADDRNOTAVAIL'
.note EADDRNOTAVAIL (249)
.us Can't assign requested address
.endnote
.*
.section IPC/Network Software -- Operational Errors
.*
.begnote $setptnt 22
.ix 'errno' 'ENETDOWN'
.note ENETDOWN (250)
.us Network is down
.ix 'errno' 'ENETUNREACH'
.note ENETUNREACH (251)
.us Network is unreachable
.ix 'errno' 'ENETRESET'
.note ENETRESET (252)
.us Network dropped connection on reset
.ix 'errno' 'ECONNABORTED'
.note ECONNABORTED (253)
.us Software caused connection abort
.ix 'errno' 'ECONNRESET'
.note ECONNRESET (254)
.us Connection reset by peer
.ix 'errno' 'ENOBUFS'
.note ENOBUFS (255)
.us No buffer space available
.ix 'errno' 'EISCONN'
.note EISCONN (256)
.us Socket is already connected
.ix 'errno' 'ENOTCONN'
.note ENOTCONN (257)
.us Socket is not connected
.ix 'errno' 'ESHUTDOWN'
.note ESHUTDOWN (258)
.us Can't send after socket shutdown
.ix 'errno' 'ETOOMANYREFS'
.note ETOOMANYREFS (259)
.us Too many references: can't splice
.ix 'errno' 'ETIMEDOUT'
.note ETIMEDOUT (260)
.us Connection timed out
.ix 'errno' 'ECONNREFUSED'
.note ECONNREFUSED (261)
.us Connection refused
.ix 'errno' 'EHOSTDOWN'
.note EHOSTDOWN (264)
.us Host is down
.ix 'errno' 'EHOSTUNREACH'
.note EHOSTUNREACH (265)
.us No route to host
.endnote
.*
.section QNX Specific
.*
.begnote $setptnt 22
.ix 'errno' 'ENOREMOTE'
.note ENOREMOTE (1000)
.us Must be done on local machine
.ix 'errno' 'ENONDP'
.note ENONDP (1001)
.us Need an NDP (8087...) to run
.ix 'errno' 'EBADFSYS'
.note EBADFSYS (1002)
.us Corrupted file system detected
.ix 'errno' 'ENO32BIT'
.note ENO32BIT (1003)
.us 32-bit integer fields were used
.ix 'errno' 'ENOVPE'
.note ENOVPE (1004)
.us No proc entry available for virtual process
.ix 'errno' 'ENONETQ'
.note ENONETQ (1005)
.us Process manager-to-net enqueuing failed
.ix 'errno' 'ENONETMAN'
.note ENONETMAN (1006)
.us Could not find net manager for node number
.ix 'errno' 'EVIDBUF2SML'
.note EVIDBUF2SML (1007)
.us Told to allocate a vid buf too small
.ix 'errno' 'EVIDBUF2BIG'
.note EVIDBUF2BIG (1008)
.us Told to allocate a vid buf too big
.ix 'errno' 'EMORE'
.note EMORE (1009)
.cw !
.us More to do; send message again
.cw ;
.ix 'errno' 'ECTRLTERM'
.note ECTRLTERM (1010)
.us Remap to controlling terminal
.ix 'errno' 'ENOLIC'
.note ENOLIC (1011)
.us No license
.endnote
.*
.endlevel
