.*
.*
.dirctv NAME
.*
.np
The "NAME" directive is used to provide a name for the executable file
generated by the &lnkname..
The format of the "NAME" directive (short form "N") is as follows.
.mbigbox
    NAME exe_file
.embigbox
.synote
.mnote exe_file
is a file specification for the name of the executable file.
Under UNIX, or if the "NOEXTENSION" option was specified, no file extension
is appended. In all other cases, a file extension suitable for the
current executable file format is appended if no file extension is specified.
.esynote
.np
Consider the following example.
.exam begin
&sysprompt.&lnkcmd &syst_drctv name myprog file test, test2, test3
.exam end
.pc
The linker is instructed to generate an executable file called
"myprog.&exeextn" if you are running a DOS, OS/2 or Windows-hosted
version of the linker.
If you are running a UNIX-hosted version of the linker, or the "NOEXTENSION"
option was specified, an executable file called "myprog" will be generated.
.autonote Notes:
.note
No file extension was given when the executable file name was
specified.
The linker assumes a file extension that depends on the format of the
executable file being generated.
If you are running a UNIX-hosted version of the linker, or the "NOEXTENSION"
option was specified, no file extension will be assumed.
The section entitled :HDREF refid='xformat'. describes the
"FORMAT" directive and how the file extension is chosen for each
executable file format.
.note
If no "NAME" directive is present, the executable file will have the
file name of the first object file processed by the linker.
If the first object file processed is called "test.&obj" and no "NAME"
directive is specified, an executable file called "test.&exeextn" will
be generated if you are running a DOS or OS/2-hosted version of the
linker.
If you are running a UNIX-hosted version of the linker, or the "NOEXTENSION"
option was used, an executable file called "test" will be generated.
.endnote
