.chap *refid=winfn16 Special Windows API Functions
.*
.np
.ix 'Windows 3.x extender' 'special functions'
.ix 'API special functions'
On rare occasions, you want to use 16-bit far pointers directly in a
Windows function.  Since all Windows functions in the 32-bit
environment are expecting 32-bit near pointers, you cannot simply use
the 16-bit far pointer directly in the function.
.np
The following functions are special versions of Windows API functions
that do NOT convert any of the pointers from 32-bit to 16-bit.
.ix 'Windows 3.x extender' '_16xxx functions'
.ix '_16xxx functions'
There are _16 versions of all Windows API functions that accept data
pointers.
:ZSL compact.
:ZLI._16AddAtom
:ZLI._16AddFontResource
:ZLI._16AdjustWindowRect
:ZLI._16AdjustWindowRectEx
:ZLI._16AnimatePalette
:ZLI._16AnsiLower
:ZLI._16AnsiLowerBuff
:ZLI._16AnsiToOem
:ZLI._16AnsiToOemBuff
:ZLI._16AnsiUpper
:ZLI._16AnsiUpperBuff
:ZLI._16BuildCommDCB
:ZLI._16CallMsgFilter
:ZLI._16ChangeMenu
:ZLI._16ClientToScreen
:ZLI._16ClipCursor
:ZLI._16CopyMetaFile
:ZLI._16CopyRect
:ZLI._16CreateBitmap
:ZLI._16CreateBitmapIndirect
:ZLI._16CreateBrushIndirect
:ZLI._16CreateCursor
:ZLI._16CreateDC
:ZLI._16CreateDialog
:ZLI._16CreateDialogIndirect
:ZLI._16CreateDialogIndirectParam
:ZLI._16CreateDialogParam
:ZLI._16CreateDIBitmap
:ZLI._16CreateEllipticRgnIndirect
:ZLI._16CreateFont
:ZLI._16CreateFontIndirect
:ZLI._16CreateIC
:ZLI._16CreateIcon
:ZLI._16CreateMetaFile
:ZLI._16CreatePalette
:ZLI._16CreatePenIndirect
:ZLI._16CreatePolygonRgn
:ZLI._16CreatePolyPolygonRgn
:ZLI._16CreateRectRgnIndirect
:ZLI._16CreateWindow
:ZLI._16CreateWindowEx
:ZLI._16DialogBox
:ZLI._16DialogBoxIndirect
:ZLI._16DialogBoxIndirectParam
:ZLI._16DialogBoxParam
:ZLI._16DispatchMessage
:ZLI._16DlgDirList
:ZLI._16DlgDirListComboBox
:ZLI._16DlgDirSelect
:ZLI._16DlgDirSelectComboBox
:ZLI._16DPtoLP
:ZLI._16DrawFocusRect
:ZLI._16DrawText
:ZLI._16EndPaint
:ZLI._16EnumChildWindows
:ZLI._16EnumFonts
:ZLI._16EnumMetaFile
:ZLI._16EnumObjects
:ZLI._16EnumProps
:ZLI._16EnumTaskWindows
:ZLI._16EnumWindows
:ZLI._16EqualRect
:ZLI._16Escape
:ZLI._16ExtTextOut
:ZLI._16FillRect
:ZLI._16FindAtom
:ZLI._16FindResource
:ZLI._16FindWindow
:ZLI._16FrameRect
:ZLI._16FreeProcInstance
:ZLI._16GetAtomName
:ZLI._16GetBitmapBits
:ZLI._16GetCaretPos
:ZLI._16GetCharWidth
:ZLI._16GetClassInfo
:ZLI._16GetClassName
:ZLI._16GetClientRect
:ZLI._16GetClipboardFormatName
:ZLI._16GetClipBox
:ZLI._16GetCodeInfo
:ZLI._16GetCommError
:ZLI._16GetCommState
:ZLI._16GetCursorPos
:ZLI._16GetDIBits
:ZLI._16GetDlgItemInt
:ZLI._16GetDlgItemText
:ZLI._16GetEnvironment
:ZLI._16GetKeyboardState
:ZLI._16GetKeyNameText
:ZLI._16GetMenuString
:ZLI._16GetMetaFile
:ZLI._16GetModuleFileName
:ZLI._16GetModuleHandle
:ZLI._16GetObject
:ZLI._16GetPaletteEntries
:ZLI._16GetPriorityClipboardFormat
:ZLI._16GetPrivateProfileInt
:ZLI._16GetPrivateProfileString
:ZLI._16GetProcAddress
:ZLI._16GetProfileInt
:ZLI._16GetProfileString
:ZLI._16GetProp
:ZLI._16GetRgnBox
:ZLI._16GetScrollRange
:ZLI._16GetSystemDirectory
:ZLI._16GetSystemPaletteEntries
:ZLI._16GetTabbedTextExtent
:ZLI._16GetTempFileName
:ZLI._16GetTextExtent
:ZLI._16GetTextFace
:ZLI._16GetTextMetrics
:ZLI._16GetUpdateRect
:ZLI._16GetWindowRect
:ZLI._16GetWindowsDirectory
:ZLI._16GetWindowText
:ZLI._16GlobalAddAtom
:ZLI._16GlobalFindAtom
:ZLI._16GlobalGetAtomName
:ZLI._16GlobalNotify
:ZLI._16GrayString
:ZLI._16InflateRect
:ZLI._16IntersectRect
:ZLI._16InvalidateRect
:ZLI._16InvertRect
:ZLI._16IsDialogMessage
:ZLI._16IsRectEmpty
:ZLI._16LineDDA
:ZLI._16LoadAccelerators
:ZLI._16LoadBitmap
:ZLI._16LoadCursor
:ZLI._16LoadIcon
:ZLI._16LoadLibrary
:ZLI._16LoadMenu
:ZLI._16LoadMenuIndirect
:ZLI._16LoadModule
:ZLI._16LoadString
:ZLI._16LPtoDP
:ZLI._16MakeProcInstance
:ZLI._16MapDialogRect
:ZLI._16MessageBox
:ZLI._16OemToAnsi
:ZLI._16OemToAnsiBuff
:ZLI._16OffsetRect
:ZLI._16OpenComm
:ZLI._16OpenFile
:ZLI._16OutputDebugString
:ZLI._16PlayMetaFileRecord
:ZLI._16Polygon
:ZLI._16Polyline
:ZLI._16PolyPolygon
:ZLI._16PtInRect
:ZLI._16ReadComm
:ZLI._16RectInRegion
:ZLI._16RectVisible
:ZLI._16RegisterClipboardFormat
:ZLI._16RegisterWindowMessage
:ZLI._16RemoveFontResource
:ZLI._16RemoveProp
:ZLI._16ScreenToClient
:ZLI._16ScrollDC
:ZLI._16ScrollWindow
:ZLI._16SetBitmapBits
:ZLI._16SetCommState
:ZLI._16SetDIBits
:ZLI._16SetDIBitsToDevice
:ZLI._16SetDlgItemText
:ZLI._16SetEnvironment
:ZLI._16SetKeyboardState
:ZLI._16SetPaletteEntries
:ZLI._16SetProp
:ZLI._16SetRect
:ZLI._16SetRectEmpty
:ZLI._16SetResourceHandler
:ZLI._16SetSysColors
:ZLI._16SetTimer
:ZLI._16SetWindowsHook
:ZLI._16SetWindowText
:ZLI._16StretchDIBits
:ZLI._16TabbedTextOut
:ZLI._16TextOut
:ZLI._16ToAscii
:ZLI._16TrackPopupMenu
:ZLI._16TranslateAccelerator
:ZLI._16TranslateMDISysAccel
:ZLI._16TranslateMessage
:ZLI._16UnhookWindowsHook
:ZLI._16UnionRect
:ZLI._16UnregisterClass
:ZLI._16ValidateRect
:ZLI._16WinExec
:ZLI._16WinHelp
:ZLI._16WriteComm
:ZLI._16WritePrivateProfileString
:ZLI._16WriteProfileString
:ZLI._16_lread
:ZLI._16_lwrite
:ZeSL.
